//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ImageLinkUnit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "WPCTRMemo"
#pragma link "WPCTRRich"
#pragma link "WPRTEDefs"
#pragma link "WPRTEPaint"  //<-- manually added !
#pragma link "WPObj_Image"  //<-- manually added !
#pragma resource "*.dfm"
TForm1 *Form1;

bool ExportFile = false;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    // Load an image from a file. The image can come from a database
    ImageLink->Caption = ExtractFilePath(Application->ExeName) + "logo.bmp";
    Image1->Picture->LoadFromFile(ImageLink->Caption);

    // just as test, assign event handler in code. For some unknown reason it is
    // not possible to assign WPRichText1->OnTextObjectPaint due to linker error.
    // asigning in IDE is no problem.
    WPRichText1->Memo->OnTextObjectPaint = &WPRichText1TextObjectPaint;

    // also assign the other events in code (IDE works, too)
    WPRichText1->AfterImageSaving = &WPRichText1AfterImageSaving;
    WPRichText1->OnPrepareImageforSaving = WPRichText1PrepareImageforSaving;   
}
//---------------------------------------------------------------------------
void __fastcall TForm1::InsertClick(TObject *Sender)
{
    int i = StrToInt(HowMany->Text);
    while(i-->0)
    {
     TWPTextObj *obj = WPRichText1->TextObjects->InsertNewObject(wpobjImage);
     obj->Source = "LOGO";
     obj->Width  = 1000;
     obj->Height = 1000;
    }
    WPRichText1->InputString("\r",0); // new paragraph
    WPRichText1->DelayedReformat();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveButtonClick(TObject *Sender)
{
   WPRichText1->Save("","");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadButtonClick(TObject *Sender)
{
   WPRichText1->Load("","");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WPRichText1TextObjectPaint(TObject *Sender,
      TWPTextObj *pobj, TCanvas *toCanvas, int XRes, int YRes, int X,
      int Y, int W, int H, int BASE, TWPVirtPage *PageRef,
      TWPTextObjectPaintModes Modes,
      const TWPPaintExtraParams &CanvasExtraAttr,
      TWPTextObjectPaintResult &ContinueMode)
{
    if(CompareText(pobj->Source,"LOGO")==0)
    {
       toCanvas->StretchDraw(Rect(X,Y,X+W,Y+H),
          Image1->Picture->Graphic);
       ContinueMode = ContinueMode >> wpobjPaintRedCross // remove
                                   << wpObjPaintContents; // add;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExportClick(TObject *Sender)
{
  ExportFile = true;
  WPRichText1->Save("","");
  ExportFile = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WPRichText1AfterImageSaving(
      TWPRTFDataCollection *RTFData, TWPCustomTextWriter *Writer,
      TWPTextObj *TextObject)
{
  if(ExportFile)
  {
    if(CompareText(TextObject->Source,"LOGO")==0)
    {
      TWPObject *tempobj = TextObject->ObjRef;
      TextObject->ObjRef = 0; // remove
      tempobj->Free(); // and free
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WPRichText1PrepareImageforSaving(
      TWPRTFDataCollection *RTFData, TWPCustomTextWriter *Writer,
      TWPTextObj *TextObject, bool &DontSave)
{
  if(ExportFile)
  {
     if(CompareText(TextObject->Source,"LOGO")==0)
     {
       TWPOImage *tempobj = new TWPOImage(WPRichText1->HeaderFooter);
       tempobj->LoadFromFile(ImageLink->Caption);
       TextObject->ObjRef = tempobj;
       // Make sure the RTFData is written, not just the link!
       // The link would be saved since the property 'Source' was used!
       Writer->StoreOptions = Writer->StoreOptions<<soAlwaysEmbedFilesInRTF;

     }
  }
}
//---------------------------------------------------------------------------
